#include <SPI.h>
#include "Ucglib.h"
#define interruptPin 2

int Ymax = 128;               //屏幕的竖向像素数
int Xmax = 160;               //屏幕的横向像素数
int Xcent = Xmax / 2;         //x中位
int base = 118;               //基线高度
int scanline = 105;           //雷达扫描线长度
int outcircle=80;
int midcircle=60;
int midcircle2=40;
int incircle=20;
int x=90;
int distance=50;
Ucglib_ST7735_18x128x160_HWSPI ucg(/*cd=*/ 9, /*cs=*/ 10, /*reset=*/ 8);
void fix_font() 
{
  ucg.setColor(0, 180, 0);
  ucg.setPrintPos(70,46);
  ucg.print("1.00");
  ucg.setPrintPos(70,66);
  ucg.print("0.75");
  ucg.setPrintPos(70,86);
  ucg.print("0.50");
  ucg.setPrintPos(70,106);
  ucg.print("0.25");
}
void fix()
{
  ucg.setColor(0, 40, 0);
  //画基线圆盘
  ucg.drawDisc(Xcent, base+1, 3, UCG_DRAW_ALL); 
  ucg.drawCircle(Xcent, base+1, outcircle, UCG_DRAW_UPPER_LEFT);
  ucg.drawCircle(Xcent, base+1, outcircle, UCG_DRAW_UPPER_RIGHT);
  ucg.drawCircle(Xcent, base+1, midcircle, UCG_DRAW_UPPER_LEFT);
  ucg.drawCircle(Xcent, base+1, midcircle, UCG_DRAW_UPPER_RIGHT);
  ucg.drawCircle(Xcent, base+1, midcircle2, UCG_DRAW_UPPER_LEFT);
  ucg.drawCircle(Xcent, base+1, midcircle2, UCG_DRAW_UPPER_RIGHT);
  ucg.drawCircle(Xcent, base+1, incircle, UCG_DRAW_UPPER_LEFT);
  ucg.drawCircle(Xcent, base+1, incircle, UCG_DRAW_UPPER_RIGHT);
  ucg.drawLine(0, base+1, Xmax,base+1);     
  ucg.setColor(0, 120, 0);
}
void setup() {
  ucg.begin(UCG_FONT_MODE_SOLID); //初始化屏幕
  ucg.setRotate90();              //设置成横屏  如果屏幕显示方向是反的，可以修改函数 setRotate90 或 setRotate270     
  Serial.begin(9600);             //设置串口传输率
  ucg.clearScreen();
  //cls();
  ucg.setFontMode(UCG_FONT_MODE_SOLID);
  ucg.setFont(ucg_font_orgv01_hr);
}

void loop() {
  if(true){
    if(false){
      ucg.clearScreen();
      fix();
      fix_font();  //重绘屏幕背景元素
      return;
    }
    if (distance < 100){
      ucg.setColor(255,0,0);
      ucg.drawDisc(0.8*distance*cos(radians(x))+Xcent,-0.8*distance*sin(radians(x))+base, 1, UCG_DRAW_ALL);
    }
    else{ //超过1米以上的，用黄色画在边缘区域示意
      ucg.setColor(255,255,0);
      ucg.drawDisc((outcircle-1)*cos(radians(x))+Xcent,-(outcircle-1)*sin(radians(x))+base, 1, UCG_DRAW_ALL);
    }
  }
}
